Skip to main content

Serving gRPC API Reference

The Michelangelo AI serving control plane exposes five gRPC services that manage the full lifecycle of inference infrastructure and model deployments. All services are defined in proto/api/v2/.

New to this reference? See How to Read the gRPC API Reference for the shared CRUD-plus-list pattern, the Required column, and how undocumented fields are shown. For the architecture these services implement, see Serving Overview.


InferenceServerService​

InferenceServer Service defines the InferenceServer related methods, such as CRUD and list.

CreateInferenceServer​

CreateInferenceServer(CreateInferenceServerRequest) → CreateInferenceServerResponse

Create a new InferenceServer with the given spec.

Request fields

FieldTypeRequiredDescription
inference_serverInferenceServerYesThe metadata and spec of the InferenceServer to be created.
create_optionsk8s.io.apimachinery.pkg.apis.meta.v1.CreateOptionsNo—

Response fields

FieldTypeDescription
inference_serverInferenceServerThe created InferenceServer.

GetInferenceServer​

GetInferenceServer(GetInferenceServerRequest) → GetInferenceServerResponse

Get the specified InferenceServer.

Request fields

FieldTypeRequiredDescription
namestringYesName of the InferenceServer.
namespacestringYesObject name and auth scope.
get_optionsk8s.io.apimachinery.pkg.apis.meta.v1.GetOptionsNo—

Response fields

FieldTypeDescription
inference_serverInferenceServerThe requested InferenceServer.

UpdateInferenceServer​

UpdateInferenceServer(UpdateInferenceServerRequest) → UpdateInferenceServerResponse

Update a InferenceServer with the given spec.

Request fields

FieldTypeRequiredDescription
inference_serverInferenceServerYesThe metadata and spec of the InferenceServer to be updated.
update_optionsk8s.io.apimachinery.pkg.apis.meta.v1.UpdateOptionsNo—

Response fields

FieldTypeDescription
inference_serverInferenceServerThe updated InferenceServer.

DeleteInferenceServer​

DeleteInferenceServer(DeleteInferenceServerRequest) → DeleteInferenceServerResponse

Delete a InferenceServer.

Request fields

FieldTypeRequiredDescription
namestringYesName of the InferenceServer.
namespacestringYesObject name and auth scope.
delete_optionsk8s.io.apimachinery.pkg.apis.meta.v1.DeleteOptionsNo—

Response fields

The response message has no fields.


DeleteInferenceServerCollection​

DeleteInferenceServerCollection(DeleteInferenceServerCollectionRequest) → DeleteInferenceServerCollectionResponse

Delete collection of InferenceServer.

Request fields

FieldTypeRequiredDescription
namespacestringYesObject name and auth scope.
delete_optionsk8s.io.apimachinery.pkg.apis.meta.v1.DeleteOptionsNo—
list_optionsk8s.io.apimachinery.pkg.apis.meta.v1.ListOptionsNo—

Response fields

The response message has no fields.


ListInferenceServer​

ListInferenceServer(ListInferenceServerRequest) → ListInferenceServerResponse

List objects of type InferenceServer.

Note: Watch and list across all namespaces are not supported.

Request fields

FieldTypeRequiredDescription
namespacestringYes—
list_optionsk8s.io.apimachinery.pkg.apis.meta.v1.ListOptionsNo—
list_options_extmichelangelo.api.ListOptionsExtNo—

Response fields

FieldTypeDescription
inference_server_listInferenceServerList—

DeploymentService​

Deployment Service defines the Deployment related methods, such as CRUD and list.

CreateDeployment​

CreateDeployment(CreateDeploymentRequest) → CreateDeploymentResponse

Create a new Deployment with the given spec.

Request fields

FieldTypeRequiredDescription
deploymentDeploymentYesThe metadata and spec of the Deployment to be created.
create_optionsk8s.io.apimachinery.pkg.apis.meta.v1.CreateOptionsNo—

Response fields

FieldTypeDescription
deploymentDeploymentThe created Deployment.

GetDeployment​

GetDeployment(GetDeploymentRequest) → GetDeploymentResponse

Get the specified Deployment.

Request fields

FieldTypeRequiredDescription
namestringYesName of the Deployment.
namespacestringYesObject name and auth scope.
get_optionsk8s.io.apimachinery.pkg.apis.meta.v1.GetOptionsNo—

Response fields

FieldTypeDescription
deploymentDeploymentThe requested Deployment.

UpdateDeployment​

UpdateDeployment(UpdateDeploymentRequest) → UpdateDeploymentResponse

Update a Deployment with the given spec.

Request fields

FieldTypeRequiredDescription
deploymentDeploymentYesThe metadata and spec of the Deployment to be updated.
update_optionsk8s.io.apimachinery.pkg.apis.meta.v1.UpdateOptionsNo—

Response fields

FieldTypeDescription
deploymentDeploymentThe updated Deployment.

DeleteDeployment​

DeleteDeployment(DeleteDeploymentRequest) → DeleteDeploymentResponse

Delete a Deployment.

Request fields

FieldTypeRequiredDescription
namestringYesName of the Deployment.
namespacestringYesObject name and auth scope.
delete_optionsk8s.io.apimachinery.pkg.apis.meta.v1.DeleteOptionsNo—

Response fields

The response message has no fields.


DeleteDeploymentCollection​

DeleteDeploymentCollection(DeleteDeploymentCollectionRequest) → DeleteDeploymentCollectionResponse

Delete collection of Deployment.

Request fields

FieldTypeRequiredDescription
namespacestringYesObject name and auth scope.
delete_optionsk8s.io.apimachinery.pkg.apis.meta.v1.DeleteOptionsNo—
list_optionsk8s.io.apimachinery.pkg.apis.meta.v1.ListOptionsNo—

Response fields

The response message has no fields.


ListDeployment​

ListDeployment(ListDeploymentRequest) → ListDeploymentResponse

List objects of type Deployment.

Note: Watch and list across all namespaces are not supported.

Request fields

FieldTypeRequiredDescription
namespacestringYes—
list_optionsk8s.io.apimachinery.pkg.apis.meta.v1.ListOptionsNo—
list_options_extmichelangelo.api.ListOptionsExtNo—

Response fields

FieldTypeDescription
deployment_listDeploymentList—

RevisionService​

Revision Service defines the Revision related methods, such as CRUD and list.

CreateRevision​

CreateRevision(CreateRevisionRequest) → CreateRevisionResponse

Create a new Revision with the given spec.

Request fields

FieldTypeRequiredDescription
revisionRevisionYesThe metadata and spec of the Revision to be created.
create_optionsk8s.io.apimachinery.pkg.apis.meta.v1.CreateOptionsNo—

Response fields

FieldTypeDescription
revisionRevisionThe created Revision.

GetRevision​

GetRevision(GetRevisionRequest) → GetRevisionResponse

Get the specified Revision.

Request fields

FieldTypeRequiredDescription
namestringYesName of the Revision.
namespacestringYesObject name and auth scope.
get_optionsk8s.io.apimachinery.pkg.apis.meta.v1.GetOptionsNo—

Response fields

FieldTypeDescription
revisionRevisionThe requested Revision.

UpdateRevision​

UpdateRevision(UpdateRevisionRequest) → UpdateRevisionResponse

Update a Revision with the given spec.

Request fields

FieldTypeRequiredDescription
revisionRevisionYesThe metadata and spec of the Revision to be updated.
update_optionsk8s.io.apimachinery.pkg.apis.meta.v1.UpdateOptionsNo—

Response fields

FieldTypeDescription
revisionRevisionThe updated Revision.

DeleteRevision​

DeleteRevision(DeleteRevisionRequest) → DeleteRevisionResponse

Delete a Revision.

Request fields

FieldTypeRequiredDescription
namestringYesName of the Revision.
namespacestringYesObject name and auth scope.
delete_optionsk8s.io.apimachinery.pkg.apis.meta.v1.DeleteOptionsNo—

Response fields

The response message has no fields.


DeleteRevisionCollection​

DeleteRevisionCollection(DeleteRevisionCollectionRequest) → DeleteRevisionCollectionResponse

Delete collection of Revision.

Request fields

FieldTypeRequiredDescription
namespacestringYesObject name and auth scope.
delete_optionsk8s.io.apimachinery.pkg.apis.meta.v1.DeleteOptionsNo—
list_optionsk8s.io.apimachinery.pkg.apis.meta.v1.ListOptionsNo—

Response fields

The response message has no fields.


ListRevision​

ListRevision(ListRevisionRequest) → ListRevisionResponse

List objects of type Revision.

Note: Watch and list across all namespaces are not supported.

Request fields

FieldTypeRequiredDescription
namespacestringYes—
list_optionsk8s.io.apimachinery.pkg.apis.meta.v1.ListOptionsNo—
list_options_extmichelangelo.api.ListOptionsExtNo—

Response fields

FieldTypeDescription
revision_listRevisionList—

ClusterService​

Cluster Service defines the Cluster related methods, such as CRUD and list.

CreateCluster​

CreateCluster(CreateClusterRequest) → CreateClusterResponse

Create a new Cluster with the given spec.

Request fields

FieldTypeRequiredDescription
clusterClusterYesThe metadata and spec of the Cluster to be created.
create_optionsk8s.io.apimachinery.pkg.apis.meta.v1.CreateOptionsNo—

Response fields

FieldTypeDescription
clusterClusterThe created Cluster.

GetCluster​

GetCluster(GetClusterRequest) → GetClusterResponse

Get the specified Cluster.

Request fields

FieldTypeRequiredDescription
namestringYesName of the Cluster.
namespacestringYesObject name and auth scope.
get_optionsk8s.io.apimachinery.pkg.apis.meta.v1.GetOptionsNo—

Response fields

FieldTypeDescription
clusterClusterThe requested Cluster.

UpdateCluster​

UpdateCluster(UpdateClusterRequest) → UpdateClusterResponse

Update a Cluster with the given spec.

Request fields

FieldTypeRequiredDescription
clusterClusterYesThe metadata and spec of the Cluster to be updated.
update_optionsk8s.io.apimachinery.pkg.apis.meta.v1.UpdateOptionsNo—

Response fields

FieldTypeDescription
clusterClusterThe updated Cluster.

DeleteCluster​

DeleteCluster(DeleteClusterRequest) → DeleteClusterResponse

Delete a Cluster.

Request fields

FieldTypeRequiredDescription
namestringYesName of the Cluster.
namespacestringYesObject name and auth scope.
delete_optionsk8s.io.apimachinery.pkg.apis.meta.v1.DeleteOptionsNo—

Response fields

The response message has no fields.


DeleteClusterCollection​

DeleteClusterCollection(DeleteClusterCollectionRequest) → DeleteClusterCollectionResponse

Delete collection of Cluster.

Request fields

FieldTypeRequiredDescription
namespacestringYesObject name and auth scope.
delete_optionsk8s.io.apimachinery.pkg.apis.meta.v1.DeleteOptionsNo—
list_optionsk8s.io.apimachinery.pkg.apis.meta.v1.ListOptionsNo—

Response fields

The response message has no fields.


ListCluster​

ListCluster(ListClusterRequest) → ListClusterResponse

List objects of type Cluster.

Note: Watch and list across all namespaces are not supported.

Request fields

FieldTypeRequiredDescription
namespacestringYes—
list_optionsk8s.io.apimachinery.pkg.apis.meta.v1.ListOptionsNo—
list_options_extmichelangelo.api.ListOptionsExtNo—

Response fields

FieldTypeDescription
cluster_listClusterList—

RayClusterService​

RayCluster Service defines the RayCluster related methods, such as CRUD and list.

CreateRayCluster​

CreateRayCluster(CreateRayClusterRequest) → CreateRayClusterResponse

Create a new RayCluster with the given spec.

Request fields

FieldTypeRequiredDescription
ray_clusterRayClusterYesThe metadata and spec of the RayCluster to be created.
create_optionsk8s.io.apimachinery.pkg.apis.meta.v1.CreateOptionsNo—

Response fields

FieldTypeDescription
ray_clusterRayClusterThe created RayCluster.

GetRayCluster​

GetRayCluster(GetRayClusterRequest) → GetRayClusterResponse

Get the specified RayCluster.

Request fields

FieldTypeRequiredDescription
namestringYesName of the RayCluster.
namespacestringYesObject name and auth scope.
get_optionsk8s.io.apimachinery.pkg.apis.meta.v1.GetOptionsNo—

Response fields

FieldTypeDescription
ray_clusterRayClusterThe requested RayCluster.

UpdateRayCluster​

UpdateRayCluster(UpdateRayClusterRequest) → UpdateRayClusterResponse

Update a RayCluster with the given spec.

Request fields

FieldTypeRequiredDescription
ray_clusterRayClusterYesThe metadata and spec of the RayCluster to be updated.
update_optionsk8s.io.apimachinery.pkg.apis.meta.v1.UpdateOptionsNo—

Response fields

FieldTypeDescription
ray_clusterRayClusterThe updated RayCluster.

DeleteRayCluster​

DeleteRayCluster(DeleteRayClusterRequest) → DeleteRayClusterResponse

Delete a RayCluster.

Request fields

FieldTypeRequiredDescription
namestringYesName of the RayCluster.
namespacestringYesObject name and auth scope.
delete_optionsk8s.io.apimachinery.pkg.apis.meta.v1.DeleteOptionsNo—

Response fields

The response message has no fields.


DeleteRayClusterCollection​

DeleteRayClusterCollection(DeleteRayClusterCollectionRequest) → DeleteRayClusterCollectionResponse

Delete collection of RayCluster.

Request fields

FieldTypeRequiredDescription
namespacestringYesObject name and auth scope.
delete_optionsk8s.io.apimachinery.pkg.apis.meta.v1.DeleteOptionsNo—
list_optionsk8s.io.apimachinery.pkg.apis.meta.v1.ListOptionsNo—

Response fields

The response message has no fields.


ListRayCluster​

ListRayCluster(ListRayClusterRequest) → ListRayClusterResponse

List objects of type RayCluster.

Note: Watch and list across all namespaces are not supported.

Request fields

FieldTypeRequiredDescription
namespacestringYes—
list_optionsk8s.io.apimachinery.pkg.apis.meta.v1.ListOptionsNo—
list_options_extmichelangelo.api.ListOptionsExtNo—

Response fields

FieldTypeDescription
ray_cluster_listRayClusterList—

Next Steps​